﻿//creación panel lateral
function Botones(viewer, options) {
    Autodesk.Viewing.Extension.call(this, viewer, options);
    var _viewer = viewer;
    var _this = this;
    _this.load = function () {
        createBotones();
        return true;
    };
    _this.unload = function () {
        deleteBotones();
        return true;
    };
    //function createBotones() {
    //    var ctrlGroup = new Autodesk.Viewing.UI.ControlGroup(
    //        'LateralToolbar.ControlGroup'
    //    );
    //    createPanelButton(ctrlGroup);
    //    this.viewer.toolbar.addControl(ctrlGroup);
    //}

    function createBotones() {
        var ctrlGroup = new Autodesk.Viewing.UI.ControlGroup(
            'LateralToolbar.ControlGroup'
        );
        createPanelButton(ctrlGroup);
        // this.viewer.toolbar.addControl(ctrlGroup);
        //Creo un nuevo toolbar
        var toolbar = new Autodesk.Viewing.UI.ToolBar('toolbar-extension');
        //Añado el ctrlGroup al toolbar
        toolbar.addControl(ctrlGroup);
        //Creo un nuevo <div> contenedor del toolbar
        var toolbarDivHtml = '<div id="divToolbar"> </div>';
        //Añado el contenedor al viewer
        $(_viewer.container).append(toolbarDivHtml);
        // Doy stylo al <div>
        $('#divToolbar').css({
            'top': '50%',
            'left': '0%',
            'z-index': '100',
            'position': 'absolute'
        });
        //añado el toolbar al <div>
        $('#divToolbar')[0].appendChild(toolbar.container);
    }

    function deleteBotones() {
        $('#LateralToolbar.ControlGroup').remove();
    }
};
Botones.prototype = Object.create(Autodesk.Viewing.Extension.prototype);
Botones.prototype.constructor = Botones;
Autodesk.Viewing.theExtensionManager.registerExtension('Botones', Botones);
// Creación de botones
//function createPanelButton(ctrl) {
//    var buttonInspecion = new Autodesk.Viewing.UI.Button('showInformacion');
//    buttonInspecion.onClick = function (e) {
//        showInformacion();
//    };
//    ctrl.addControl(buttonInspecion);
//    buttonInspecion.setToolTip('Propiedades de los objetos BIM');
//    buttonInspecion.setIcon('adsk-icon-first');
//    // ver https://forge.autodesk.com/blog/what-icons-are-provided-viewer-stylesheet para la lista de iconos en adsk
//}

function createPanelButton(ctrl) {
    var buttonInspecion = new Autodesk.Viewing.UI.Button('showInformacion');
    buttonInspecion.onClick = function (e) {
        showInformacion();
    };
    ctrl.addControl(buttonInspecion);
    buttonInspecion.setToolTip('Propiedades de los objetos BIM');
    buttonInspecion.setIcon('adsk-icon-first');
    // ver https://forge.autodesk.com/blog/what-icons-are-provided-viewer-stylesheet 
    //para la lista de iconos en adsk
    //Creamos botón para ver todos los usuarios
    var buttonAllUsers = new Autodesk.Viewing.UI.Button('showAllUsers');
    buttonAllUsers.onClick = function (e) {
        showAllUsers();
    };
    ctrl.addControl(buttonAllUsers);
    buttonAllUsers.setToolTip('Ver todos los usuarios de la cuenta');
    buttonAllUsers.setIcon('adsk-icon-second');
    //Creamos botón para ver issues
    var buttonloadQualityIssues = new Autodesk.Viewing.UI.Button('loadQualityIssues');
    buttonloadQualityIssues.onClick = function (e) {
        showQualityIssues();
    };
    ctrl.addControl(buttonloadQualityIssues);
    buttonloadQualityIssues.setToolTip('Ver incidencias del proyecto');
    buttonloadQualityIssues.setIcon('adsk-icon-refresh');
    //Creamos botón para crear issues
    var buttoncreateQualityIssues = new
        Autodesk.Viewing.UI.Button('createQualityIssues');
    buttoncreateQualityIssues.onClick = function (e) {
        createQualityIssues();
    };
    ctrl.addControl(buttoncreateQualityIssues);
    buttoncreateQualityIssues.setToolTip('Crear incidencia en el proyecto');
    buttoncreateQualityIssues.setIcon('adsk-icon-plus');
}
function showInformacion() {
    if (viewer.getSelection().length == 1) {
        var objSelected = viewer.getSelection()[0];
        var misprop = this.viewer.getProperties(objSelected, (props) => {
            // Creamos una instancia del árbol
            var instanceTree = viewer.model.getData().instanceTree;
            //Obtenemos el nombre del nodo seleccionado
            var mtext = instanceTree.getNodeName(objSelected);
            // Output properties to console
            console.log(instanceTree);
            console.log(mtext);
        },
            function (error) {
                console.log(error);
            });
    }
    else {
        alert('Debe seleccionar un solo objeto');
    }
}

function showAllUsers() {
    var nodoVersion = $("#userHubs").jstree().get_selected(true)[0];
    var nodoParents = nodoVersion.parents;
    var nNodos = nodoParents.length;
    var nodoRoot = nodoParents[nNodos - 2].split('/');
    var hubId = nodoRoot[nodoRoot.length - 1];
    jQuery.ajax({
        url: '/api/forge/user/showAllUsers',
        data: { hubId },
        success: function (users) {
            console.log(users);
        }
    });
}


function showQualityIssues() {
    var nodoVersion = $("#userHubs").jstree().get_selected(true)[0];
    var nodoParents = nodoVersion.parents;
    var nNodos = nodoParents.length;

    var nodoRoot = nodoParents[nNodos - 3].split('/');
    var hubId = nodoRoot[nodoRoot.length - 3];
    var projectId = nodoRoot[nodoRoot.length - 1];

     var urn = "";
     var nodoVersionArray = nodoVersion.id.split('|');
     if (nodoVersionArray.length > 1) {
         urn = nodoVersionArray[0];
     }
     else {
         var nodoParentsArray = (nodoParents[0]).split('/');
         urn = nodoParentsArray[nodoParentsArray.length - 1];
     }

    jQuery.ajax({
        url: '/api/forge/issues/container',
        data: { hubId, projectId },
        success: function (containerId) {
            console.log(containerId);
            jQuery.ajax({
                url: '/api/forge/issues/listado',
                data: { containerId, hubId , urn},
                success: function (issues) {
                    console.log(issues);
                    showIssues(issues);
                }
            });
        }
    });
}

function createQualityIssues() {

    var nodoVersion = $("#userHubs").jstree().get_selected(true)[0];
    var nodoParents = nodoVersion.parents;
    var nNodos = nodoParents.length;

    var nodoRoot = nodoParents[nNodos - 3].split('/');
    var hubId = nodoRoot[nodoRoot.length - 3];
    var projectId = nodoRoot[nodoRoot.length - 1];

    var target_urn = "";
    var starting_version;

    var nodoVersionArray = nodoVersion.id.split('|');
    if (nodoVersionArray.length > 1) {
        target_urn = nodoVersionArray[0];
        starting_version = nodoVersionArray[3];
    }
    else {
        var nodoParentsArray = (nodoParents[0]).split('/');
        target_urn = nodoParentsArray[nodoParentsArray.length - 1];
        var nodoTextArray = nodoVersion.text.split(' ');
        starting_version = nodoTextArray[0].split(':')[1];
    }
    jQuery.ajax({
        url: '/api/forge/issues/container',
        data: { hubId, projectId },
        success: function (containerId) {
            console.log(containerId);
            createIssue(target_urn, starting_version, containerId);
        }
    });
}
