﻿class MenuContextual extends Autodesk.Viewing.Extension {
    constructor(viewer, options) {
        super(viewer, options);
        this.onCreacionContextualMenuItem = this.onCreacionContextualMenuItem.bind(this);
    }
    get menuId() {
        return 'ItemMenuContextual';
    }

    onCreacionContextualMenuItem(menu, status) {
        if (status.hasSelected) {
            if (viewer.getSelection().length == 1) {
                menu.push({
                    title: 'Ver Imagen del objeto',
                    target: () => {
                        BuscarNombreImagen(function callback(miNameImagen) {
                            if (!miNameImagen.includes('<')) {
                                CrearPanel(miNameImagen);
                            }
                        });
                    }
                });
            }//cierro if getSelection()=1 
                else {
                    menu.push({
                        title: 'Ver objetos seleccionados',
                        target: () => {
                            const selSet = this.viewer.getSelection();
                            this.viewer.clearSelection();
                            const color = new THREE.Vector4(255 / 255, 0, 0, 1);
                            for (let i = 0; i < selSet.length; i++) {
                                this.viewer.setThemingColor(selSet[i], color);
                            }
                            alert('Se han seleccionado estos ' + selSet.length + ' objetos');
                        }
                    });
                }//cierro else
        }// cierro (status.hasSelected
        else {
           // alert('Debe seleccionar un solo objeto');
            menu.push({
            title: 'Borrar modificaciones de color',
             target: () => {
            this.viewer.clearThemingColors();
              }
             });
        }
    }

    load() {
        // Creación menu contextual item
        this.viewer.registerContextMenuCallback(
            this.menuId,
            this.onCreacionContextualMenuItem
        );
        return true;
    }
    unload() {
        // Borrado de todas los items
        this.viewer.unregisterContextMenuCallback(this.menuId);
        return true;
    }
}
Autodesk.Viewing.theExtensionManager.registerExtension('MenuContextual', MenuContextual);

function BuscarNombreImagen(callback) {
    //Solo tenemos un objeto seleccionado
    var miImagenName;
    var objSelected = viewer.getSelection()[0];
    this.viewer.getProperties(objSelected, (props) => {
        // Imprimimos las propiedades en la consola
        console.log(props);
        for (var i = 0; i < props.properties.length; i += 1) {
            mProp = props.properties[i];
            if (mProp.attributeName == "Type Image") {
                miImagenName = mProp.displayValue;
                callback(miImagenName);
                break;
            }
        };
    });
}

function CrearPanel(imageName) {
    var nodoVersion = $("#userHubs").jstree().get_selected(true)[0];
    var nodoParents = nodoVersion.parents;
    console.log(nodoParents);
    var nNodos = nodoParents.length;
    var nodoTopFolder = nodoParents[nNodos - 4].split('/');
    var projectId = nodoTopFolder[6];
    var folderTopInfoId = nodoTopFolder[8];
    jQuery.ajax({
        url: '/api/forge/searchProjectContent',
        data: { projectId, folderTopInfoId, imageName },
        success: function (streamImage) {
            var itemMenuContextual = $("#ItemMenuContextual");
            var panel = itemMenuContextual.panel;
            if (panel == null) {
                panel = new PanelVacioBIM(viewer, viewer.container, 'PanelPropiedadesBIM', 'Imagen del objeto');
                itemMenuContextual.panel = panel;
            }
            var panelId = document.getElementById('PanelPropiedadesBIM');
            panelId.style.display = "block";
            var ficheroJPG_a_txt = [""];

            if (streamImage != null) {
                ficheroJPG_a_txt = ['<figure class="figure">',
                    ' <img alt="' + imageName + '" src="data:image/jpeg;base64,' + streamImage + '" class= "figure-img img-fluid" alt = "Responsive image" > ',
                    ' <figcaption class="figure-caption">Imagen del objeto BIM.</figcaption>',
                    '</figure>',]
            };
            var html = [
                '<div class="uicomponent-panel-controls-container" >',
                '<div class="contend panel panel-default" ;>',
                ficheroJPG_a_txt.join('\n'),
                '</div>',
                '</div>'
            ].join('\n');
            var div = document.getElementById('ContenidoPanelBIM');
            div.innerHTML = html;
        }
    });//cierro JQuery
}