/* 
 * Forge SDK
 *
 * The Forge Platform contains an expanding collection of web service components that can be used with Autodesk cloud-based products or your own technologies. Take advantage of Autodesk’s expertise in design and engineering.
 *
 * OpenAPI spec version: 0.1.0
 * Contact: forge.help@autodesk.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.IO;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reflection;
using RestSharp;
using NUnit.Framework;

using Autodesk.Forge.Client;
using Autodesk.Forge;
using Autodesk.Forge.Model;

namespace Autodesk.Forge.Test
{
    /// <summary>
    ///  Class for testing DerivativesApi
    /// </summary>
    /// <remarks>
    /// This file is automatically generated by Swagger Codegen.
    /// Please update the test case below to test the API endpoint.
    /// </remarks>
    [TestFixture]
    public class DerivativesApiTests
    {
        private DerivativesApi instance;

        /// <summary>
        /// Setup before each unit test
        /// </summary>
        [SetUp]
        public void Init()
        {
            instance = new DerivativesApi();
        }

        /// <summary>
        /// Clean up after each unit test
        /// </summary>
        [TearDown]
        public void Cleanup()
        {

        }

        /// <summary>
        /// Test an instance of DerivativesApi
        /// </summary>
        [Test]
        public void InstanceTest()
        {
            // TODO uncomment below to test 'IsInstanceOfType' DerivativesApi
            //Assert.IsInstanceOfType(typeof(DerivativesApi), instance, "instance is a DerivativesApi");
        }

        
        /// <summary>
        /// Test DeleteManifest
        /// </summary>
        [Test]
        public void DeleteManifestTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string urn = null;
            //var response = instance.DeleteManifest(urn);
            //Assert.IsInstanceOf<Result> (response, "response is Result");
        }
        
        /// <summary>
        /// Test GetDerivativeManifest
        /// </summary>
        [Test]
        public void GetDerivativeManifestTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string urn = null;
            //string derivativeUrn = null;
            //int? range = null;
            //instance.GetDerivativeManifest(urn, derivativeUrn, range);
            
        }
        
        /// <summary>
        /// Test GetFormats
        /// </summary>
        [Test]
        public void GetFormatsTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //DateTime? ifModifiedSince = null;
            //string acceptEncoding = null;
            //var response = instance.GetFormats(ifModifiedSince, acceptEncoding);
            //Assert.IsInstanceOf<Formats> (response, "response is Formats");
        }
        
        /// <summary>
        /// Test GetManifest
        /// </summary>
        [Test]
        public void GetManifestTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string urn = null;
            //string acceptEncoding = null;
            //var response = instance.GetManifest(urn, acceptEncoding);
            //Assert.IsInstanceOf<Manifest> (response, "response is Manifest");
        }
        
        /// <summary>
        /// Test GetMetadata
        /// </summary>
        [Test]
        public void GetMetadataTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string urn = null;
            //string acceptEncoding = null;
            //var response = instance.GetMetadata(urn, acceptEncoding);
            //Assert.IsInstanceOf<Metadata> (response, "response is Metadata");
        }
        
        /// <summary>
        /// Test GetModelviewMetadata
        /// </summary>
        [Test]
        public void GetModelviewMetadataTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string urn = null;
            //string guid = null;
            //string acceptEncoding = null;
            //var response = instance.GetModelviewMetadata(urn, guid, acceptEncoding);
            //Assert.IsInstanceOf<Metadata> (response, "response is Metadata");
        }
        
        /// <summary>
        /// Test GetModelviewProperties
        /// </summary>
        [Test]
        public void GetModelviewPropertiesTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string urn = null;
            //string guid = null;
            //string acceptEncoding = null;
            //var response = instance.GetModelviewProperties(urn, guid, acceptEncoding);
            //Assert.IsInstanceOf<Metadata> (response, "response is Metadata");
        }
        
        /// <summary>
        /// Test GetThumbnail
        /// </summary>
        [Test]
        public void GetThumbnailTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //string urn = null;
            //int? width = null;
            //int? height = null;
            //var response = instance.GetThumbnail(urn, width, height);
            //Assert.IsInstanceOf<System.IO.Stream> (response, "response is System.IO.Stream");
        }
        
        /// <summary>
        /// Test Translate
        /// </summary>
        [Test]
        public void TranslateTest()
        {
            // TODO uncomment below to test the method and replace null with proper value
            //JobPayload job = null;
            //bool? xAdsForce = null;
            //var response = instance.Translate(job, xAdsForce);
            //Assert.IsInstanceOf<Job> (response, "response is Job");
        }
        
    }

}
