/* 
 * Forge SDK
 *
 * The Forge Platform contains an expanding collection of web service components that can be used with Autodesk cloud-based products or your own technologies. Take advantage of Autodesk’s expertise in design and engineering.
 *
 * OpenAPI spec version: 0.1.0
 * Contact: forge.help@autodesk.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace Autodesk.Forge.Model
{
    /// <summary>
    /// CreatePdf
    /// </summary>
    [DataContract]
    public partial class CreatePdf :  IEquatable<CreatePdf>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CreatePdf" /> class.
        /// </summary>
        /// <param name="IncludeMarkups">Jsonapi.</param>
        /// <param name="IncludeCallouts">Data.</param>
        /// <param name="UrlType">Data.</param>
        /// <param name="BaseUrl">Data.</param>
        public CreatePdf(bool includeMarkups = true, bool includeCallouts = true, string urlType = null, string baseUrl = null)
        {
            this.IncludeMarkups = includeMarkups;
            this.IncludeCallouts = includeCallouts;
            this.UrlType = urlType;
            this.BaseUrl = baseUrl;
        }
        
        /// <summary>
        /// Gets or Sets Jsonapi
        /// </summary>
        [DataMember(Name= "includeMarkups", EmitDefaultValue=true)]
        public bool IncludeMarkups { get; set; }
        /// <summary>
        /// Gets or Sets Data
        /// </summary>
        [DataMember(Name= "includeCallouts", EmitDefaultValue=true)]
        public bool IncludeCallouts { get; set; }
        /// <summary>
        /// Gets or Sets Data
        /// </summary>
        [DataMember(Name= "urlType", EmitDefaultValue=false)]
        public string UrlType { get; set; }
        /// <summary>
        /// Gets or Sets Data
        /// </summary>
        [DataMember(Name= "baseUrl", EmitDefaultValue=false)]
        public string BaseUrl { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class CreatePdf {\n");
            sb.Append("  IncludeMarkups: ").Append(IncludeMarkups).Append("\n");
            sb.Append("  IncludeCallouts: ").Append(IncludeCallouts).Append("\n");
            sb.Append("  UrlType: ").Append(UrlType).Append("\n");
            sb.Append("  BaseUrl: ").Append(BaseUrl).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as CreatePdf);
        }

        /// <summary>
        /// Returns true if CreateRef instances are equal
        /// </summary>
        /// <param name="other">Instance of CreateRef to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(CreatePdf other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.IncludeMarkups == other.IncludeMarkups ||
                    this.IncludeMarkups.Equals(other.IncludeMarkups)
                ) && 
                (
                    this.IncludeCallouts == other.IncludeCallouts ||
                    this.IncludeCallouts.Equals(other.IncludeCallouts)
                ) && 
                (
                    this.UrlType == other.UrlType ||
                    this.UrlType != null &&
                    this.UrlType.Equals(other.UrlType)
                ) && 
                (
                    this.BaseUrl == other.BaseUrl ||
                    this.BaseUrl != null &&
                    this.BaseUrl.Equals(other.BaseUrl)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                hash = hash * 59 + this.IncludeMarkups.GetHashCode();
                hash = hash * 59 + this.IncludeCallouts.GetHashCode();
                if (this.UrlType != null)
                    hash = hash * 59 + this.UrlType.GetHashCode();
                if (this.BaseUrl != null)
                    hash = hash * 59 + this.BaseUrl.GetHashCode();
                return hash;
            }
        }
    }

}

