/* 
 * Forge SDK
 *
 * The Forge Platform contains an expanding collection of web service components that can be used with Autodesk cloud-based products or your own technologies. Take advantage of Autodesk’s expertise in design and engineering.
 *
 * OpenAPI spec version: 0.1.0
 * Contact: forge.help@autodesk.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace Autodesk.Forge.Model
{
    /// <summary>
    /// Group of outputs
    /// </summary>
    [DataContract]
    public partial class JobPayloadOutput :  IEquatable<JobPayloadOutput>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="JobPayloadOutput" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected JobPayloadOutput() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="JobPayloadOutput" /> class.
        /// </summary>
        /// <param name="Formats">Group of requested formats/types. User can request multiple formats. (required).</param>
        public JobPayloadOutput(List<JobPayloadItem> Formats = null, JobPayloadDestination destination = null)
        {
            // to ensure "Formats" is required (not null)
            if (Formats == null)
            {
                throw new InvalidDataException("Formats is a required property for JobPayloadOutput and cannot be null");
            }
            else
            {
                this.Formats = Formats;
            }

            Destination = destination;
        }

        /// <summary>
        /// Group of requested formats/types. User can request multiple formats.
        /// </summary>
        /// <value>Group of requested formats/types. User can request multiple formats.</value>
        [DataMember(Name="destination", EmitDefaultValue=false)]
        public JobPayloadDestination Destination { get; set; }
        
        /// <summary>
        /// Group of requested formats/types. User can request multiple formats.
        /// </summary>
        /// <value>Group of requested formats/types. User can request multiple formats.</value>
        [DataMember(Name="formats", EmitDefaultValue=false)]
        public List<JobPayloadItem> Formats { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class JobPayloadOutput {\n");
            sb.Append("  Destination: ").Append(Destination).Append("\n");
            sb.Append("  Formats: ").Append(Formats).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as JobPayloadOutput);
        }

        /// <summary>
        /// Returns true if JobPayloadOutput instances are equal
        /// </summary>
        /// <param name="other">Instance of JobPayloadOutput to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(JobPayloadOutput other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.Formats == other.Formats ||
                    this.Formats != null &&
                    this.Formats.SequenceEqual(other.Formats)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.Formats != null)
                    hash = hash * 59 + this.Formats.GetHashCode();
                return hash;
            }
        }
    }

}

