/* 
 * Forge SDK
 *
 * The Forge Platform contains an expanding collection of web service components that can be used with Autodesk cloud-based products or your own technologies. Take advantage of Autodesk’s expertise in design and engineering.
 *
 * OpenAPI spec version: 0.1.0
 * Contact: forge.help@autodesk.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace Autodesk.Forge.Model
{
    /// <summary>
    /// OAuthError
    /// </summary>
    [DataContract]
    public partial class OAuthError :  IEquatable<OAuthError>
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="OAuthError" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected OAuthError() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="OAuthError" /> class.
        /// </summary>
        /// <param name="ErrorMessage">ErrorMessage (required).</param>
        /// <param name="ErrorCode">ErrorCode (required).</param>
        /// <param name="ErrorResponse">ErrorResponse (required).</param>
        public OAuthError(string ErrorMessage = null, long? ErrorCode = null, string ErrorResponse = null)
        {
            // to ensure "ErrorMessage" is required (not null)
            if (ErrorMessage == null)
            {
                throw new InvalidDataException("ErrorMessage is a required property for OAuthError and cannot be null");
            }
            else
            {
                this.ErrorMessage = ErrorMessage;
            }
            // to ensure "ErrorCode" is required (not null)
            if (ErrorCode == null)
            {
                throw new InvalidDataException("ErrorCode is a required property for OAuthError and cannot be null");
            }
            else
            {
                this.ErrorCode = ErrorCode;
            }
            // to ensure "ErrorResponse" is required (not null)
            if (ErrorResponse == null)
            {
                throw new InvalidDataException("ErrorResponse is a required property for OAuthError and cannot be null");
            }
            else
            {
                this.ErrorResponse = ErrorResponse;
            }
        }

        /// <summary>
        /// Gets or Sets ErrorMessage
        /// </summary>
        [DataMember(Name="errorMessage", EmitDefaultValue=false)]
        public string ErrorMessage { get; set; }
        /// <summary>
        /// Gets or Sets ErrorCode
        /// </summary>
        [DataMember(Name="errorCode", EmitDefaultValue=false)]
        public long? ErrorCode { get; set; }
        /// <summary>
        /// Gets or Sets ErrorResponse
        /// </summary>
        [DataMember(Name="errorResponse", EmitDefaultValue=false)]
        public string ErrorResponse { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class OAuthError {\n");
            sb.Append("  ErrorMessage: ").Append(ErrorMessage).Append("\n");
            sb.Append("  ErrorCode: ").Append(ErrorCode).Append("\n");
            sb.Append("  ErrorResponse: ").Append(ErrorResponse).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as OAuthError);
        }

        /// <summary>
        /// Returns true if OAuthError instances are equal
        /// </summary>
        /// <param name="other">Instance of OAuthError to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(OAuthError other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return
                (
                    this.ErrorMessage == other.ErrorMessage ||
                    this.ErrorMessage != null &&
                    this.ErrorMessage.Equals(other.ErrorMessage)
                ) &&
                (
                    this.ErrorCode == other.ErrorCode ||
                    this.ErrorCode != null &&
                    this.ErrorCode.Equals(other.ErrorCode)
                ) &&
                (
                    this.ErrorResponse == other.ErrorResponse ||
                    this.ErrorResponse != null &&
                    this.ErrorResponse.Equals(other.ErrorResponse)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.ErrorMessage != null)
                    hash = hash * 59 + this.ErrorMessage.GetHashCode();
                if (this.ErrorCode != null)
                    hash = hash * 59 + this.ErrorCode.GetHashCode();
                if (this.ErrorResponse != null)
                    hash = hash * 59 + this.ErrorResponse.GetHashCode();
                return hash;
            }
        }
    }

}
