/* 
 * Forge SDK
 *
 * The Forge Platform contains an expanding collection of web service components that can be used with Autodesk cloud-based products or your own technologies. Take advantage of Autodesk’s expertise in design and engineering.
 *
 * OpenAPI spec version: 0.1.0
 * Contact: forge.help@autodesk.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace Autodesk.Forge.Model
{
    /// <summary>
    /// PostBucketsPayloadAllow
    /// </summary>
    [DataContract]
    public partial class PostBucketsPayloadAllow :  IEquatable<PostBucketsPayloadAllow>
    {
        /// <summary>
        /// Acceptable values: `full` or `read` 
        /// </summary>
        /// <value>Acceptable values: `full` or `read` </value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum AccessEnum
        {
            
            /// <summary>
            /// Enum Full for "full"
            /// </summary>
            [EnumMember(Value = "full")]
            Full,
            
            /// <summary>
            /// Enum Read for "read"
            /// </summary>
            [EnumMember(Value = "read")]
            Read
        }

        /// <summary>
        /// Acceptable values: `full` or `read` 
        /// </summary>
        /// <value>Acceptable values: `full` or `read` </value>
        [DataMember(Name="access", EmitDefaultValue=false)]
        public AccessEnum? Access { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="PostBucketsPayloadAllow" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected PostBucketsPayloadAllow() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="PostBucketsPayloadAllow" /> class.
        /// </summary>
        /// <param name="AuthId">The application key to grant access to (required).</param>
        /// <param name="Access">Acceptable values: &#x60;full&#x60; or &#x60;read&#x60;  (required).</param>
        public PostBucketsPayloadAllow(string AuthId = null, AccessEnum? Access = null)
        {
            // to ensure "AuthId" is required (not null)
            if (AuthId == null)
            {
                throw new InvalidDataException("AuthId is a required property for PostBucketsPayloadAllow and cannot be null");
            }
            else
            {
                this.AuthId = AuthId;
            }
            // to ensure "Access" is required (not null)
            if (Access == null)
            {
                throw new InvalidDataException("Access is a required property for PostBucketsPayloadAllow and cannot be null");
            }
            else
            {
                this.Access = Access;
            }
        }
        
        /// <summary>
        /// The application key to grant access to
        /// </summary>
        /// <value>The application key to grant access to</value>
        [DataMember(Name="authId", EmitDefaultValue=false)]
        public string AuthId { get; set; }
        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class PostBucketsPayloadAllow {\n");
            sb.Append("  AuthId: ").Append(AuthId).Append("\n");
            sb.Append("  Access: ").Append(Access).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="obj">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object obj)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            return this.Equals(obj as PostBucketsPayloadAllow);
        }

        /// <summary>
        /// Returns true if PostBucketsPayloadAllow instances are equal
        /// </summary>
        /// <param name="other">Instance of PostBucketsPayloadAllow to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(PostBucketsPayloadAllow other)
        {
            // credit: http://stackoverflow.com/a/10454552/677735
            if (other == null)
                return false;

            return 
                (
                    this.AuthId == other.AuthId ||
                    this.AuthId != null &&
                    this.AuthId.Equals(other.AuthId)
                ) && 
                (
                    this.Access == other.Access ||
                    this.Access != null &&
                    this.Access.Equals(other.Access)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            // credit: http://stackoverflow.com/a/263416/677735
            unchecked // Overflow is fine, just wrap
            {
                int hash = 41;
                // Suitable nullity checks etc, of course :)
                if (this.AuthId != null)
                    hash = hash * 59 + this.AuthId.GetHashCode();
                if (this.Access != null)
                    hash = hash * 59 + this.Access.GetHashCode();
                return hash;
            }
        }
    }

}

